const express = require('express')
const mongoose = require('mongoose');
const artigoModel = require('../models/artigo');

const router = express.Router()

router.get("/", async (req, res) => {   
    
    const artigos = await artigoModel.find();
    
    res.render("artigos", {artigos:artigos})
})

router.get("/new", (req, res) => {
    res.render("novoartigo")
})

router.post("/new", async (req, res) => {
    const novoArtigo = await artigoModel.create({
        titulo: req.body.titulo,
        conteudo: req.body.conteudo
    });

    res.redirect("/artigo/"+String(novoArtigo._id));
});

router.route("/:id")
.get(async (req,res) => {
    const artigo = await artigoModel.findOne({_id:req.artigoId});
    
    res.render("verartigo", {artigo:artigo})
})
.post((req,res) => {
    res.send("POST artigo "+String(req.artigoId));
})
.delete((req,res) => {
    res.send("DELETE artigo "+String(req.artigoId));
});

    // por último
router.param("id", (req,res,next,id) => {
    if(mongoose.Types.ObjectId.isValid(id))
    {
        req.artigoId = new mongoose.Types.ObjectId(id);
        next();
    }
    else
    {
        res.status(400);
        res.send("<h1>Página não encontrada</h1><p>O valor informado para identificação do artigo não é válido</p>");
        return;
    }
})

// exportar o router para ser possível utilizá-lo no server.js
module.exports = router